# Katabatic Documentation

# Katabatic - Routing Toolbox

List of all members | Public Member Functions | Protected Member Functions
Grid< GCellT > Class Template Reference

Template Class for Regular Grid. More...

Inheritance diagram for Grid< GCellT >:
[legend]

## Public Member Functions

GCellT * | getGCell (unsigned int index) const
GCellT * | getGCell (const Point p) const
GCellT * | getGCell (const Point p1, const Point p2) const
GCellT * | getGCellLeft (const GCellT *gcell) const
GCellT * | getGCellRight (const GCellT *gcell) const
GCellT * | getGCellUp (const GCellT *gcell) const
GCellT * | getGCellDown (const GCellT *gcell) const
GenericCollection< GCellT * > | getGCells ()
GenericCollection< GCellT * > | getGCellsColumn (unsigned int column, unsigned int rowStart, unsigned int rowStop)
GenericCollection< GCellT * > | getGCellsRow (unsigned int row, unsigned int columnStart, unsigned int columnStop)
Public Member Functions inherited from BaseGrid
void | destroy ()
const Box & | getBoundingBox () const
unsigned int | getColumns () const
unsigned int | getRows () const
unsigned int | getRawSize () const
unsigned int | getIndex (unsigned int c, unsigned int r) const
unsigned int | getRow (unsigned int) const
unsigned int | getColumn (unsigned int) const
const Axis & | getXGrads () const
const Axis & | getYGrads () const

## Protected Member Functions

| Grid (const Box &)
Protected Member Functions inherited from BaseGrid
| BaseGrid (const Box &)

## Detailed Description

### template<typename GCellT>
class Katabatic::Grid< GCellT >

Template Class for Regular Grid.

Contains all general purpose methods depending on the GCell type and geometrical computations. The internal storage is still not implemented in this class.

## Constructor & Destructor Documentation

## ◆ Grid()

Grid | ( | const Box & | bb | ) |

inlineprotected

Grid constructor.

## Member Function Documentation

## ◆ getGCell() [1/3]

CGellT * getGCell | ( | unsigned int | index | ) | const

inline

Returns: The grid object at linear index `index` in the vector. If `index` is out of bounds, return `NULL`.

Referenced by GCellTopology::doRp_AccessPad(), GCellTopology::doRp_AutoContacts(), and anonymous_namespace{LoadGrByNet.cpp}::singleGCell().

## ◆ getGCell() [2/3]

CGellT * getGCell | ( | const Point | p | ) | const

inline

Returns: The grid object which is under position `p`.

## ◆ getGCell() [3/3]

CGellT * getGCell | ( | const Point | p1,
|  | const Point | p2
| ) |  | const

inline

Returns: The grid object which is under position `p1` and `p2`. Not very clear though.

## ◆ getGCellLeft()

CGellT * getGCellLeft | ( | const GCellT * | gcell | ) | const

inline

Returns: The left neighbor of `gcell`, `NULL` if it is the leftmost one.

Referenced by GCell::getLeft().

## ◆ getGCellRight()

CGellT * getGCellRight | ( | const GCellT * | gcell | ) | const

inline

Returns: The rigth neighbor of `gcell`, `NULL` if it is the rightmost one.

Referenced by GCell::getRight().

## ◆ getGCellUp()

CGellT * getGCellUp | ( | const GCellT * | gcell | ) | const

inline

Returns: The upper neighbor of `gcell`, `NULL` if it is the uppermost one.

Referenced by GCell::getUp().

## ◆ getGCellDown()

CGellT * getGCellDown | ( | const GCellT * | gcell | ) | const

inline

Returns: The down neighbor of `gcell`, `NULL` if it is the downmost one.

Referenced by GCell::getDown().

## ◆ getGCells()

GenericCollection< CGellT * > getGCells | ( |  | ) |

inline

Returns: A GCellT Hurricane collection built upon the linear GCellT vector of the grid.

## ◆ getGCellsColumn()

GenericCollection< CGellT * > getGCellsColumn | ( | unsigned int | column,
|  | unsigned int | rowStart,
|  | unsigned int | rowStop
| ) |  |

inline

Returns: A GCellT Hurricane collection that contains the part of `column` starting from `rowStart` to `rowStop` inclusive.

Referenced by KatabaticEngine::createDetailedGrid().

## ◆ getGCellsRow()

GenericCollection< CGellT * > getGCellsRow | ( | unsigned int | row,
|  | unsigned int | columnStart,
|  | unsigned int | columnStop
| ) |  |

inline

Returns: A GCellT Hurricane collection that contains the part of `row` starting from `columnStart` to `columnStop` inclusive.

Referenced by KatabaticEngine::createDetailedGrid().

The documentation for this class was generated from the following files:

- Grid.h
- Grid.dox